#!/usr/local/bin/perl
#### եHTTPեץ mkup.pl V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/11/07 V2.20 ѥ᡼ִб
####                  ξǼ³Τʤ顼åɽХ
#### 2000/09/20 V2.11 sjisƥȤǤʤեबɽʤХ
#### 2000/03/12 V2.02 chmod 666chmod o+wѹ
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣
#### 1999/09/26 V1.15 ưΥ顼Фʤ褦
#### 1998/12/16 V1.03 prev/today/nextб
#### 1998/12/15 V1.02 ǽεưǤΤȤlastuploadեդǵư褦ˤ
#### 1998/12/14 V1.01 ƥȥ⡼ɡʹ˷ɽˤɲá
####                  եιб 
#### 1998/12/13 V1.00  

require "libgns.pl";

$NKFCODE_MKUP = '-e';  # EUC-JP˸

{
	$argc = $#ARGV+1;

	&Setup();

	$DBLIST[10] = "D-Head";
	$DBLIST[11] = "D-Memo1";
	$DBLIST[20] = "D-Memo2";
	$DBLIST[21] = "D-Foot";
	$DBLIST[30] = "B-Head";
	$DBLIST[40] = "B-Foot";
	$DBLIST[50] = "L1-Head";
	$DBLIST[51] = "L1-Foot";
	$DBLIST[52] = "L2-Head";
	$DBLIST[53] = "L2-Foot";
	$DBLIST[60] = "TB-Head";
	$DBLIST[61] = "TB-Foot";
	$DBLIST[96] = "Ping";
	$DBLIST[97] = "Macro";
	$DBLIST[98] = "Item";
	$DBLIST[99] = "URI";

	$command = "";
	$pass = "";
	if ( $argc >= 4 ) {
		$pass = $ARGV[4];
	}
	if ( $argc >= 3 ) {
		$command = $ARGV[3];
	}
	if ( $argc >= 2 ) {
		$year = $ARGV[0];
		$month = $ARGV[1];
		$day = $ARGV[2];
		if ( ($month == 99) && ($day == 99) ) {
			$diary = sprintf( $KEEPDIR . $SLASH . '%02d.html', $year );
		} else {
			if ( ($year == 0) && ($month == 0) && ($day == 0) ) {
				$lastupload = $KEEPDIR . $SLASH . $LASTUPLOADNAME;
				open( FIN, $lastupload );
				$line = <FIN>;
				( $year, $month, $day ) = split( " ", $line );
				close( FIN );
				if ( $year == 0 ) {
					@today = localtime( time );
					$year = $today[5];
					$month = $today[4]+1;
					$day = $today[3];
					$umaskback = umask( oct($DIARY_KEEP_PERM) ^ 0666 );
					open( FOUT, ">$lastupload" );
					print FOUT "$year, $month, $day\n";
					close( FOUT );
					umask( $umaskback );
				}
				if ( $year >= 1980 ) {
					system( "$PERLCMD mkd.pl $year $month $day test" );
				}
				&YMD2DAYS( $year, $month, $day );
			}
			if ( $command eq 'prev' ) {
				&YMD2DAYS( $year, $month, $day );
				&DAYS2YMD( $TOTALDAYS-1 );
				$year = $YEAR;
				$month = $MONTH;
				$day = $DATE;
			} elsif ( $command eq 'next' ) {
				&YMD2DAYS( $year, $month, $day );
				&DAYS2YMD( $TOTALDAYS+1 );
				$year = $YEAR;
				$month = $MONTH;
				$day = $DATE;
			}
			$diary = sprintf( $GETDIR . $SLASH . '%04d' . $SLASH . '%02d%02d.html',
			  $year, $month, $day
			);
			&GetDiaryPart( $year, $month, $day );
			$part = $PART;
		}
	}

	&ReadLastUpload();
	$makeindex = $LASTUPLOAD{"makeindex"}+0;
	$updateping = $LASTUPLOAD{"updateping"}+0;

	$mkup = $NKFCMD . ' -e mkup.html |';
	$fout = "|" . $NKFCMD . ' ' . $NKFCODE_MKUP;
	open( FIN, $mkup );
	open( FOUT, $fout );

	while ( $line = <FIN> ) {
		if ( $line =~ m:\@/MKUP_SOURCE/: ) {
			if ( $diary ne '' ) {
				if ( -e $diary ) {
					$cmd = $NKFCMD . ' -e ' . $diary . "|";
					open( FIN2, $cmd );
					while ( $line2 = <FIN2> ) {
						$line2 =~ s/[&]/\&amp;/g;
						print FOUT $line2;
					}
					close( FIN2 );
				}
			}
			next;
		}
		if ( $line =~ m:\@/MKUP_BODY/: ) {
			$cmd = $NKFCMD . ' -e ' . $TMPDIR . $SLASH . 'test.html |';
			open( FIN2, $cmd );
			while ( $line2 = <FIN2> ) {
				print FOUT $line2;
			}
			close( FIN2 );
			next;
		}
		if ( $line =~ m:\@/MKUP_PASS/: ) {
			if ($pass ne '') {
				$line =~ s:\@/MKUP_PASS/:$pass:g;
			}
		}
		if ( $line =~ m:\@/MKUP_MAKEINDEX/: ) {
			if ($makeindex) {
				$line =~ s:\@/MKUP_MAKEINDEX/:checked:g;
			} else {
				$line =~ s:\@/MKUP_MAKEINDEX/::g;
			}
		}
		if ( $line =~ m:\@/MKUP_UPDATEPING/: ) {
			if ($updateping) {
				$line =~ s:\@/MKUP_UPDATEPING/:checked:g;
			} else {
				$line =~ s:\@/MKUP_UPDATEPING/::g;
			}
		}
		if ( $line =~ m:\@/MKUP_EDITDB/: ) {
			$rep = "";
			if ( $year < 100 ) {
				$value = $DBLIST[$year+0];
				if ( $line =~ m:${value}: ) {
					$rep = "selected";
				}
			}
			$line =~ s:\@/MKUP_EDITDB/:$rep:;
		}
		if ( $line =~ m:\@/MKUP_TBTITLELIST/: ) {
			print FOUT "<OPTION VALUE=\"tb_0\">-- title --\n";
			$cmd = $NKFCMD . ' -e ' . $TMPDIR . $SLASH . 'tblist.txt |';
			open( FIN2, $cmd );
			$i = 1;
			while ( $line2 = <FIN2> ) {
				print FOUT "<OPTION VALUE=\"tb_$i\">$line2";
				$line2 = <FIN2>;
				$line2 = <FIN2>;
				$i++;
			}
			$line = "";
		}
		print FOUT &Replace( $line, $year, $month, $part, $day );
	}
	close( FOUT );
	close( FIN );

	&Finish();
}

0;
# [EOF]
